
//#include <avr/iom32.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


// Standard Input/Output functions
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
//#include "sms_comm.h"


#define CPU_freq 6000 KHz
#define  FT232RL_RST		PB2
#define  BUTTON_DEAD_TIME	50
int s,button_filter;
int butflag=0;
// Declare your global variables here
char sms_read[]={'A','T','+','C','M','G','R','='};
	
char status[9]={'G','E','T','S','T','A','T','U','S'};
char getrelay1[9]={'G','E','T','R','E','L','A','Y','1'};
char setrelay1[9]={'S','E','T','R','E','L','A','Y','1'};
char getrelay2[9]={'G','E','T','R','E','L','A','Y','2'};
char setrelay2[9]={'S','E','T','R','E','L','A','Y','2'};
char gettemp[7]={'G','E','T','T','E','M','P'};
char nocarrier[10]={'N','O',' ','C','A','R','R','I','E','R'};
char callready[10]={'a','l','l',' ','R','e','a','d','y'};
//char dial[14]={'A','T','D','0','8','7','6','0','4','1','1','0','1',';'};

unsigned long a;
unsigned char i=0;
unsigned char j,k,m;
unsigned char proba;
unsigned char temp_array [64];
double tempcalc,tempcalc2;
int index1;
int colcount=0;
unsigned const RING [6] = {'R', 'I', 'N', 'G', '\r'};
char sms_rec[12]={'C','M','T','I',':',' ','"','S','M','"',','};
char sms_send[10]={'A','T','+','C','M','G','S','=','"','+'};
//char sms_send2[]={'A','T','+','C','M','G','S','=','"','0','8','7','6','0','4','1','1','0','0','"'};
char sms_send_number[30];
char message[160];
char smsind[6];
char sms_number[16];
char sms_read_comm[13];		//SPP
int l=0;
int flag=0;
int com_out=0;
int ring_state=0;
int t=0;
int stopbuzzer=0;
char ok[2]={'O','K'};

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 256
char rx_buffer[RX_BUFFER_SIZE];
int rx_wr_index,rx_rd_index;
volatile int rx_counter;//unsigned char
// This flag is set on USART Receiver buffer overflow
unsigned char rx_buffer_overflow;

unsigned char conf_pointer;
unsigned char Ta_pointer;
unsigned char TCN_Conf;
unsigned int TCN_Data;
unsigned char TCN_raddr,TCN_waddr;
int er;

// this function switches between UART interface of the modem being used either by the
// MCU or the FTDI chip depending on USB been plugged in
char SwitchCommChanell_USB_MCU(void);

//////////////////////////////////////////////////////////////////////////////


void Init()
{// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=T State5=0 State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;	

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=Out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=0 State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0xC0;

// Port D initialization
// Func7=Out Func6=In Func5=In Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x92;


// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 6000,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Toggle
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x10;//enable Timer/Counter 1
TCCR1B=0x01;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
//proba
OCR1BH=0x07;
OCR1BL=0x2A;

//OCR1BH=0x05;
//OCR1BL=0x52;

// External Interrupt(s) initialization
// INT0: Off
// INT1: 
// INT1 Mode: Falling Edge
// INT2: Off

GICR=0x00;//disable external interrupts
MCUCR=0x00;
MCUCSR=0x00;
GIFR=0x80;
/*
GICR|=0x80;
MCUCR=0x08;
MCUCSR=0x00;
GIFR=0x80;*/
// Timer(s)/Counter(s) Interrupt(s) initialization

//TIMSK=0x02;

//--------interrupt--------
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 115.2 kbps
//UCSRA=0x00;
//UCSRB=0x98;
//UCSRC=0x86;
//UBRRH=0x00;		//0x00;5F
//UBRRL=0x03;		//2F->>9600 at 7.3278 ;0x26;-->baudrate 9600 at clock=6 MHz


// Timer(s)/Counter(s) Interrupt(s) initialization
//TIMSK=0x00;//timer interrupt disable
TIMSK=0x08;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

//PORTB &= ~(1<<PB2);//hold FT232RL in reset
//DDRB |= 0x04;	

//PORTA &= 0b01011111;//disable SLEEP mode with RTS=0; DTR =0
//DDRA |=  0b10100000;	

SwitchCommChanell_USB_MCU();

// Global enable interrupts
asm volatile("sei");
//#asm("sei")

}

////////////////////////////////////////////////////////////////
static void putchr(char c)
{

  loop_until_bit_is_set(UCSRA, UDRE);
  UDR = c;
}
///////////////////////////////////////////////////////////////
void Send_UART(unsigned char * byte)
{
	for (;*byte;++byte)	putchr (*byte);
	putchr(13);
	}

///////////////////////////////////////////////////
void Send_UART2(unsigned char * byte)
{
	for (;*byte;++byte)	putchr (*byte);
	putchr(26);
}

////////////////////////////////////////////////////////////////////////

char getchar_UART(unsigned long timeout)
{
	char data;

	//wait given timeout
	while (timeout > 0) {
		asm volatile("cli");
		if(rx_counter != 0)
			break;
		asm volatile("sei");
		timeout--;
	}
	asm volatile("sei");

	if(timeout == 0) {
		com_out = 1;
		return 0xFF;
	}

	// get the data and advance the read pointer
	data = rx_buffer[rx_rd_index];
	if (++rx_rd_index == RX_BUFFER_SIZE)
		rx_rd_index = 0;

	asm volatile("cli");

	--rx_counter;

	asm volatile("sei");

	return data;
}

/////////////////////////////////////////////////////////////////////
// USART Receiver interrupt service routine
ISR(USART_RXC_vect)
//interrupt [USART_RXC] void usart_rx_isr(void)
{
	char status,data;
	status=UCSRA;
	data=UDR;
	if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0) {
	   
	   // add data to the pointer and advance the write pointer
	   rx_buffer[rx_wr_index] = data;
	   if (++rx_wr_index == RX_BUFFER_SIZE)
	   		rx_wr_index = 0;

	   if (++rx_counter == RX_BUFFER_SIZE) {
	      rx_counter = 0;
	      rx_buffer_overflow = 1;
	   }
	}
}


///////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Timer 1 output compare interrupt service routine
ISR(TIMER1_COMPB_vect)
{
	t++;
	TCNT1=0;	//clear TCNT1 value(to imitate CTC mode on Timer 1 B)
//1.check whether to toggle or not(buzzer_enable);
	if (stopbuzzer || (t==4000))
		TCCR1A=0x0;//disconnect Timer/Counter 1 A/B Output pin
			
}
//////////////////////////////////////////////////////////////////////////////
unsigned char Compare (void)
{
   unsigned char a, b;// temp;
   b=0;
   for (a=0; a<5; a++)
	 {
//		temp = getchar_UART();
		
	 	if (temp_array[b++] != RING[a]) return 0;		  
	 }	
	 return 1;
}

///////////////////////////////////////////////////////////////////
unsigned char Compare2 (void)
{
   unsigned char a, b;
   b=0;
   for (a=0; a!=11; a++)
	 {
	 	if (temp_array[b++] != sms_rec[a]) return 0;		  
	 }	
	 return 1;
}

////////////////////////////////////////////////////////////////////

unsigned char Comparereq (char* request)
{
   unsigned char a, b;// temp;
   b=0;
   for (a=0; a!=9; a++)
	 {
//		temp = getchar_UART();
		
	 	if (temp_array[b++] != request[a]) return 0;		  
	 }	
	 return 1;
}
//////////////////////////////////////////////////////////////////////
void gsmconfig()
{

#warning "removed checking for OK from modem, because of the shitty way the check is made!"

	Send_UART("ATE0");//disable ECHO characters
	a=65535;
	while(--a!=0);

	com_out=0;
//	if(!waitOK())
//		return;
	com_out=0;
	
	Send_UART("AT+CMGF=1");//set text SMS format
	a=65535;
	while(--a!=0);
//	if(!waitOK())
//		return;
	com_out=0;	
}
////////////////////////////////////////////////////////////////////

int waitOK()
{
	//Feature:can exit by timeout
	int l=0;
	int flag=0;
	char ok[2]={'O','K'};

	while ( (getchar_UART(100000)!=10)&& (!com_out) );
	if(com_out)
		return 0; //here exits by timeout
	
	while(ok[l++]==getchar_UART(100000))
	{
		flag=flag+1;
	}
	
	while ((getchar_UART(100000)!=10)&& (!com_out) )
	{
		l=l;
	}

	return flag;
}
///////////////////////////////////////////////////////////
int waitplus()
{
	com_out=0;
	int l=0;
	int flag=0;
	while (	(getchar_UART(100000)!=10) && (!com_out))
	{
		l=l;
	}

	if(!com_out)
		proba=getchar_UART(100000);
	else return 0; //here exits by timeout
	
	if(proba==43)
	{
		flag=flag+1;
	}
	
	return flag;
}

/////////////////////////////////////////////////////////////
void waitcarrier(void)
{
	int l=0;
	int flag=0;
	com_out=0;

	while ((getchar_UART(100000)!=10) && (!com_out))
	{
		l=l;
	}
	
	while(nocarrier[l++]==getchar_UART(100000)&& (!com_out))
	{
		flag=flag+1;
	}
	
	while ((getchar_UART(100000)!=10)&& (!com_out) )
	{
		l=l;
	}

}
//////////////////////////////////////////////////////////////////////////////////////////
int call_ready(void)
{
	//Feature: can exit by timeout 

	int match;
	char ch;

	// get the first char
	com_out = 0;
	ch = getchar_UART(100000);
	if(com_out)
		return 0;

	// check for string match, exit on first mismatch
	for(match = 0; (callready[match] != '\0') && (callready[match] == ch); match++ ) {
		ch = getchar_UART(100000);
		if(com_out)
			return 0;
	}

	return ( (match == strlen(callready)) ? 1 : 0 );
}

//////////////////////////////////////////////////////////////////////////////////////////
void Delay (unsigned long a) { while (--a!=0); }
//////////////////////////////////////////////////////////////////////////////////////////


void Togle_REL1 (void)
{
	DDRC |= 0x80;
	PORTC ^= 0x80;
}
void Set_REL1 (void)
{
	DDRC |= 0x80;
	PORTC|= 0x80;
}
void Togle_REL2 (void)
{
	DDRC |= 0x40;
	PORTC ^= 0x40;

}
void Set_REL2 (void)
{
	DDRC |= 0x40;
	PORTC |= 0x40;
}

void Togle_LED (void)
{
	DDRD |= 0x80;
	PORTD ^= 0x80;
}

void delay_ms(uint16_t ms)
{
	while(ms--) _delay_ms(1.0);
}

////////////////////////////////////////////////////////////
void SendStatus(void)
{	
	int i;

	i=0;
	
	if(PINB & 0b00000001)
		{
		sprintf(message,"IN1=1,");
		i=i+6;
		}
		else {sprintf(message,"IN1=0,");
				i=i+6;
				}
		
	if(PIND & 0b00000100)
			{
			sprintf(message +i,"IN2=1,");
			i=i+6;
			}
		else {		
			sprintf(message +i,"IN2=0,");
			i=i+6;
				}
	if(PORTC & 0b10000000)
			{
			sprintf(message +i,"RELAY1=1,");
			i=i+9;
			}
		else {		
			sprintf(message +i,"RELAY1=0,");
			i=i+9;
				}

	if(PORTC & 0b01000000)
			{
			sprintf(message +i,"RELAY2=1,");
			i=i+9;
			}
		else {		
			sprintf(message +i,"RELAY2=0,");
			i=i+9;
				}

	if(PINA & 0b00000100)
			{
			sprintf(message +i,"PINA2=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINA2=0,");
			i=i+8;
				}

	if(PINA & 0b00000010)
			{
			sprintf(message +i,"PINA1=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINA1=0,");
			i=i+8;
				}

	if(PINA & 0b00000001)
			{
			sprintf(message +i,"PINA0=1,");
			i=i+8;
			}
		else {		
			sprintf(message+i,"PINA0=0,");
			i=i+8;
				}

	if(PINB & 0b10000000)
			{
			sprintf(message +i,"PINB7=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB7=0,");
			i=i+8;
				}

	if(PINB & 0b01000000)
			{
			sprintf(message +i,"PINB6=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB6=0,");
			i=i+8;
				}

	if(PINB & 0b00100000)
			{
			sprintf(message +i,"PINB5=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB5=0,");
			i=i+8;
				}

	if(PINB & 0b00100000)
			{
			sprintf(message +i,"PINB5=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB5=0,");
			i=i+8;
				}

	if(PINB & 0b00010000)
			{
			sprintf(message +i,"PINB4=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB4=0,");
			i=i+8;
				}

	if(PINB & 0b00001000)
			{
			sprintf(message +i,"PINB3=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB3=0,");
			i=i+8;
				}

	if(PINB & 0b00000100)
			{
			sprintf(message +i,"PINB2=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB2=0,");
			i=i+8;
				}

	if(PINB & 0b00000010)
			{
			sprintf(message +i,"PINB1=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB1=0,");
			i=i+8;
				}

	if(PINB & 0b00000001)
			{
			sprintf(message +i,"PINB0=1,");
			i=i+8;
			}
		else {		
			sprintf(message +i,"PINB0=0,");
			i=i+8;
				}
	if(PIND & 0b00001000)
			{
			sprintf(message +i,"BTN=1.");
			i=i+6;
			}
		else {		
			sprintf(message +i,"BTN=0.");
			i=i+6;
				}

}
int send_sms(char * message)
{
		int k=sizeof(sms_send);

		//SPP +
		int sms_number_length=0;
		for (sms_number_length=0;sms_number_length<16;sms_number_length++)
		if (sms_number[sms_number_length]==0) break;
		memcpy(sms_send_number,sms_send,k);	//send SMS header
		memcpy(sms_send_number+k,sms_number,((sizeof(char))*sms_number_length));	//GSM number
		//SPP -
		k+=12;
		sms_send_number[k++]='"';	//collons 
		sms_send_number[k]='\0';	//terminate string
		Send_UART(sms_send_number);
		a=65535;
		
		while(--a!=0);
		if (rx_counter != 0)
			{
			while(!(proba == '>'))	//HERE sending SMS works
				proba=getchar_UART(100000);
			Send_UART2(message);
			}//end sending
		com_out=0;

		if(!waitplus())
			return 0;
		com_out=0;
	
		do 
			{
			proba=getchar_UART(100000);
			index1=index1;
			}
		while(proba != 10);	//skip first line, read message text on second line
		com_out=0;

		if(!waitOK())
			return 0;
		com_out=0;
	
		a=65535;

		return 1;
}

/////////////////////////////////////////////////////////////////////////////
/*
Following SMS request/response couples are realized:
received SMS content		sent SMS content
	GETSTATUS				EXT inputs,IN1,IN2,B1
	SETRELAY1				set Relay1
	SETRELAY2				set Relay2
*/
//=====================================================================================================
int main(void)
{
	//	asm volatile("sei");
	// Declare your local variables here
	k=0;
	er=0;
	int del1,del2;
	
	int ch;
	ch=0;
	del2=0;
	for (del1=0;del1<160;del1++)
		message[del1]= '\0';

	//init UART and I/O ports	
	Init();

	//delay_ms(400);
	a=65556;
	while(--a!=0);


///////////////////////act as PowerKey-it should be hold down about 1-2 seconds
			DDRA  = 0b00000100;//PA2 out in zero
			Delay(1500000);
			PORTA &=0b11111011;
			DDRA  &=0b11111011;//PA2 back input
////////////////////wait for Call Ready/////////////////////////////////////			
			while( call_ready() == 0 ) {
				SwitchCommChanell_USB_MCU();
			}

			gsmconfig();
//////////////////////////////////////////////////////////////////////////////////////////////////////
	while (1) {

		// check for connection of USB
		if( SwitchCommChanell_USB_MCU() == 1)
			continue;

		//TCCR1A =0x00;	
		if (rx_counter != 0) {
		 	k=0;
			del2=0;
			if( waitplus() ) {
				TCCR1A =0x00;	//disable buzzer ring sound
				m=0;
				while(m != 6) smsind[m++] = 0;		//clear SMS adress 
							
				do {
			 		proba=getchar_UART(100000);
					if ((proba != 13) && (proba != 10)) { 
						temp_array[k++]=proba;//sms message command sent  
						if(isdigit(proba))						      
							smsind[del2++]=proba;						      
					}
				} while(proba != 10); 		//LF 
				com_out=0;

				smsind[del2++]=0;
				ch=atoi(smsind);
				sprintf(sms_read_comm,"AT+CMGR=%d",ch);

				if(Compare2()){
													
					Send_UART(sms_read_comm);//send command to read SMS content
					a=65535;
					while(--a!=0);
					waitplus();
				
					k=0;
					colcount=0;
				
					do 
						{
					proba=getchar_UART(100000);
					if(proba=='"')
						colcount++;
					if(colcount==3) if(isdigit(proba))
						sms_number[k++]=proba;
						index1=index1;
						}
					while(proba != 10);	//skip first line, read message text on second line
					sms_number[k]='\0';
					com_out=0;

					k=0;
				//	temp_array[k++]=proba;
					do
  			 			{
			 		proba=getchar_UART(100000);
					if ((proba != 13) && (proba != 10))
						 temp_array[k++]=proba;//read command sent with sms message
					 	}
					while(proba != 10); 		//waiting for end of line
					com_out=0;
			
					waitOK();
					com_out=0;
				//	temp_array[k++] = 0;

					if (Comparereq(setrelay1)==1) {
						Set_REL1();		//setting Relay1
						SendStatus();	//getting port status
                        if (PORTC & 0b10000000) {
                        	send_sms(message);
						} else {
							send_sms("Command execution failure");
						}
					} else if (Comparereq(setrelay2)==1) {
						Set_REL2();		//setting Relay1
						SendStatus();	//getting port status
                        if (PORTC & 0b01000000) {
							send_sms(message);
						} else {
							send_sms("Command execution failure");
						}
					} else if(Comparereq(status)==1) { //sending port status in SMS
						Togle_LED();
						SendStatus();
						send_sms(message);
					} //end send status
						
				}//end Compare2
			}//end waitplus //UNCOMMENT THIS

/*////////////////uncoment this if you wish call support/////////////////////////////////////////////////////////////
		else
			{	k=0;
				temp_array[k++]=proba;		
				do
  			 	{
			 	proba=getchar_UART(100000);
				if (proba != 10) 
				temp_array[k++]=proba;				 
			 	}
				while(proba != 10); 		//LF 
				com_out=0;

				k=0;
				 TCCR1A =0x00;
				if(Compare())
					{
					//Togle_REL1();
					TCCR1A ^=0x10;	//	disable buzzer ring sound
					}
			}			 
*///////////////////uncoment this if you wish call support/////////////////////////////////////////////////////////////
	
	  }//end USART FIFO read  

	 
	}//end main cycle
	////////////////////////////////////////////////////////////////////////////////////////////

}

//////////////////////Config for terminal access or dialog with CPU/////////////////////////////
// returns 1 if USB connected, 0 otherwise
char SwitchCommChanell_USB_MCU(void) 
{
	static char usbConnectedPrev = -2;
	char usbConnected; 

	if(PIND & 0b00100000)
		usbConnected = 1;
	else
		usbConnected = 0;

	if(usbConnected != usbConnectedPrev) {
		if(usbConnected == 1) {
			// deinitialize the UART
			UCSRA=0x00;
			UCSRB=0x00;
			UCSRC=0x00;
			UBRRH=0x00;		
			UBRRL=0x00;

			PORTA=0x00;					//RTS,CTS,DTR,DCD - inputs
			DDRA=0x00;	

			PORTD &= 0b10111100;	//RI,RTX,DTX- inputs 
			DDRD  &= 0b10111100;
			
			// release FT232RL from reset
			PORTB &=0b11111011;
			DDRB &= 0b11111011;
		} else {
			// hold FT232RL in reset
			PORTB &=0b11111011;
			DDRB |= 0x04;	

			// initialize the UART
			PORTA &= 0b01011111;	//disable SLEEP mode with RTS=0; DTR =0
			DDRA |=  0b10100000;

			PORTD = 0b00000000;
			DDRD  = 0b10010010;

			UCSRA=0x00;
			UCSRB=0x98;
			UCSRC=0x86;
			UBRRH=0x00;	
			UBRRL=0x03;	

			// initialze serial buffer
			rx_counter = 0;
			rx_wr_index = 0;
			rx_rd_index = 0;
		}

		usbConnectedPrev = usbConnected;

		// ensure there are no spurious swithces of modes
		delay_ms(100);
	}

	return usbConnected;
}


